package org.retentionprediction;

import javax.help.HelpBroker;
import javax.help.HelpSet;

public class Globals
{
	public static HelpSet hsMainHelpSet = null;
	public static HelpBroker hbMainHelpBroker = null;
	
	public static double[][][][] dPredefinedValues = {
		// Accela instrument
		{
			// 5 min, 200 uL/min
			{
				{0, 5.045}, // Phthalate-C1
				{1, 5.854}, // Phthalate-C2
				{2, 6.219}, // Phthalate-C3a
				{3, 6.724}, // Phthalate-C3
				{4, 7.576}, // Phthalate-C4
				{5, 8.538}, // Phthalate-C5
				{6, 9.705}, // Phthalate-C6
				{7, 11.179}, // Phthalate-C7
				{8, 13.158}, // Phthalate-C8
				{20, 2.016}, // dimethylacetamide*
				{21, 3.572}, // diethylacetamide*
				{22, 5.297}, // indole*
				{25, 3.162}, // p-toluenesulfonic acid*
				{26, 4.284}, // indole-3-acetic acid*
				{31, 1.424} // adenosine*
			},
			// 20 min, 100 uL/min
			{
				{0, 12.966}, // Phthalate-C1
				{1, 16.098}, // Phthalate-C2
				{3, 19.099}, // Phthalate-C3
				{4, 21.724}, // Phthalate-C4
				{5, 24.053}, // Phthalate-C5
				{6, 26.497}, // Phthalate-C6
				{7, 29.550}, // Phthalate-C7
				{8, 33.649}, // Phthalate-C8
				{20, 2.788}, // dimethylacetamide*
				{21, 5.626}, // diethylacetamide*
				{22, 13.903}, // indole*
				{25, 3.396}, // p-toluenesulfonic acid*
				{26, 10.096}, // indole-3-acetic acid*
				{31, 2.231} // adenosine*
			},
			// 20 min, 200 uL/min
			{
				{0, 9.475}, // Phthalate-C1
				{1, 12.276}, // Phthalate-C2
				{2, 13.642}, // Phthalate-C3a
				{3, 15.001}, // Phthalate-C3
				{4, 17.337}, // Phthalate-C4
				{5, 19.383}, // Phthalate-C5
				{6, 21.220}, // Phthalate-C6
				{7, 22.961}, // Phthalate-C7
				{8, 25.051}, // Phthalate-C8
				{20, 2.018}, // dimethylacetamide*
				{21, 4.701}, // diethylacetamide*
				{22, 10.243}, // indole*
				{25, 3.684}, // p-toluenesulfonic acid*
				{26, 7.302}, // indole-3-acetic acid*
				{31, 1.407} // adenosine*
			},
			// 20 min, 400 uL/min
			{
				{0, 7.172}, // Phthalate-C1
				{1, 9.952}, // Phthalate-C2
				{2, 11.347}, // Phthalate-C3a
				{3, 12.577}, // Phthalate-C3
				{4, 14.734}, // Phthalate-C4
				{5, 16.562}, // Phthalate-C5
				{6, 18.189}, // Phthalate-C6
				{7, 19.617}, // Phthalate-C7
				{8, 20.894}, // Phthalate-C8
				{20, 1.151}, // dimethylacetamide*
				{21, 2.938}, // diethylacetamide*
				{22, 7.751}, // indole*
				{25, 2.180}, // p-toluenesulfonic acid*
				{26, 5.300}, // indole-3-acetic acid*
				{31, 0.785} // adenosine*
			},
			// 80 min, 200 uL/min
			{
				{0, 19.043}, // Phthalate-C1
				{1, 29.260}, // Phthalate-C2
				{3, 39.424}, // Phthalate-C3
				{4, 48.142}, // Phthalate-C4
				{5, 55.748}, // Phthalate-C5
				{6, 62.754}, // Phthalate-C6
				{7, 68.931}, // Phthalate-C7
				{8, 74.379}, // Phthalate-C8
				{20, 1.994}, // dimethylacetamide*
				{21, 5.757}, // diethylacetamide*
				{22, 20.520}, // indole*
				{25, 3.968}, // p-toluenesulfonic acid*
				{26, 13.002}, // indole-3-acetic acid*
				{31, 1.420} // adenosine*
			}
		},
		// Acquity instrument
		{
			// 5 min, 200 uL/min
			{
				{0, 4.304}, // Phthalate-C1
				{1, 5.037}, // Phthalate-C2
				{2, 5.335}, // Phthalate-C3a
				{3, 5.750}, // Phthalate-C3
				{4, 6.325}, // Phthalate-C4
				{5, 6.780}, // Phthalate-C5
				{6, 7.236}, // Phthalate-C6
				{7, 7.751}, // Phthalate-C7
				{8, 8.503}, // Phthalate-C8
				{20, 1.908}, // dimethylacetamide*
				{21, 2.858}, // diethylacetamide*
				{22, 4.542}, // indole*
				{25, 2.485}, // p-toluenesulfonic acid*
				{26, 3.591}, // indole-3-acetic acid*
				{31, 1.393} // adenosine*
			},
			// 20 min, 100 uL/min
			{
				{0, 11.878}, // Phthalate-C1
				{1, 14.710}, // Phthalate-C2
				{2, 15.997}, // Phthalate-C3a
				{3, 17.502}, // Phthalate-C3
				{4, 19.819}, // Phthalate-C4
				{5, 21.700}, // Phthalate-C5
				{6, 23.205}, // Phthalate-C6
				{7, 24.551}, // Phthalate-C7
				{8, 26.175}, // Phthalate-C8
				{20, 3.422}, // dimethylacetamide*
				{21, 6.570}, // diethylacetamide*
				{22, 12.789}, // indole*
				{25, 5.464}, // p-toluenesulfonic acid*
				{26, 9.343}, // indole-3-acetic acid*
				{31, 2.452} // adenosine*
			},
			// 20 min, 200 uL/min
			{
				{0, 8.442}, // Phthalate-C1
				{1, 11.175}, // Phthalate-C2
				{2, 12.523}, // Phthalate-C3a
				{3, 13.850}, // Phthalate-C3
				{4, 16.127}, // Phthalate-C4
				{5, 18.067}, // Phthalate-C5
				{6, 19.731}, // Phthalate-C6
				{7, 21.078}, // Phthalate-C7
				{8, 22.167}, // Phthalate-C8
				{20, 1.908}, // dimethylacetamide*
				{21, 3.888}, // diethylacetamide*
				{22, 9.234}, // indole*
				{25, 3.099}, // p-toluenesulfonic acid*
				{26, 6.344}, // indole-3-acetic acid*
				{31, 1.393} // adenosine*
			},
			// 20 min, 400 uL/min
			{
				{0, 6.071}, // Phthalate-C1
				{1, 8.685}, // Phthalate-C2
				{2, 10.071}, // Phthalate-C3a
				{3, 11.319}, // Phthalate-C3
				{4, 13.556}, // Phthalate-C4
				{5, 15.497}, // Phthalate-C5
				{6, 17.220}, // Phthalate-C6
				{7, 18.686}, // Phthalate-C7
				{8, 19.893}, // Phthalate-C8
				{20, 0.982}, // dimethylacetamide*
				{21, 2.269}, // diethylacetamide*
				{25, 1.718}, // p-toluenesulfonic acid*
				{26, 4.387}, // indole-3-acetic acid*
				{31, 0.705} // adenosine*
			},
			// 80 min, 200 uL/min
			{
				{0, 17.454}, // Phthalate-C1
				{1, 27.395}, // Phthalate-C2
				{2, 32.999}, // Phthalate-C3a
				{3, 37.554}, // Phthalate-C3
				{4, 46.326}, // Phthalate-C4
				{5, 54.049}, // Phthalate-C5
				{6, 61.159}, // Phthalate-C6
				{7, 67.477}, // Phthalate-C7
				{8, 72.862}, // Phthalate-C8
				{20, 1.908}, // dimethylacetamide*
				{21, 4.958}, // diethylacetamide*
				{25, 3.554}, // p-toluenesulfonic acid*
				{26, 11.810}, // indole-3-acetic acid*
				{31, 1.393} // adenosine*
			}
		}
	};

	public static String[] StationaryPhaseArray = {
		"Waters Acquity BEH C18 (2.1 x 100 mm, 1.7 um)"
	};
	
	public static double[][] dDeadTimeArray = {
		{1, 0.222428056}, 
		{0.900893604, 0.220172848}, 
		{0.804361314, 0.219557185}, 
		{0.70669484, 0.220476457}, 
		{0.607643454, 0.221867149}, 
		{0.50534969, 0.221949967}, 
		{0.402951799, 0.2375}, 
		{0.29855752, 0.24065}, 
		{0.194662481, 0.24585}, 
		{0.090966981, 0.25225}
	};
	
	public static String[] CompoundNameArray = {
		"dimethyl phthalate",
		"diethyl phthalate",
		"diallyl phthalate",
		"di-n-propyl phthalate",
		"di-n-butyl phthalate",
		"di-n-pentyl phthalate",
		"di-n-hexyl phthalate",
		"di-n-heptyl phthalate",
		"di-n-octyl phthalate",
		"acetophenone",
		"propiophenone",
		"butyrophenone",
		"valerophenone",
		"hexanophenone",
		"heptanophenone",
		"octanophenone",
		"nonanophenone",
		"decanophenone",
		"undecanophenone",
		"dodecanophenone",
		"N,N-dimethylacetamide",
		"N,N-diethylacetamide",
		"indole",
		"1-pentanesulfonic acid",
		"p-coumaric acid",
		"p-toluenesulfonic acid",
		"indole-3-acetic acid",
		"4-n-hexylaniline",
		"indole-3-propionic acid",
		"indole-3-butyric acid",
		"nortriptyline",
		"adenosine",
		"amitriptyline",
		"chlorogenic acid",
		"cortisone"
	};
	
	public static double[][][] IsocraticDataArray = {
		{{1, -0.758671992}, {0.900893604, -0.640099316}, {0.804361314, -0.409872109}, {0.70669484, -0.266636079}, {0.607643454, -0.074407373}, {0.50534969, 0.144335447}, {0.402951799, 0.368394552}, {0.29855752, 0.718484608}, {0.194662481, 1.168488016}},
		{{1, -0.837020788}, {0.900893604, -0.447191213}, {0.804361314, -0.218863926}, {0.70669484, -0.020474331}, {0.607643454, 0.217545694}, {0.50534969, 0.500236682}, {0.402951799, 0.820153044}, {0.29855752, 1.27591385}},
		{{1, -0.837020788}, {0.900893604, -0.398147107}, {0.804361314, -0.161298983}, {0.70669484, 0.083024661}, {0.607643454, 0.367341129}, {0.50534969, 0.703059879}, {0.402951799, 1.092195969}, {0.29855752, 1.636354714}},
		{{1, -0.464255722}, {0.900893604, -0.242989392}, {0.804361314, 0.008395503}, {0.70669484, 0.271032466}, {0.607643454, 0.570325596}, {0.50534969, 0.925133418}, {0.402951799, 1.344470872}},
		{{1, -0.301976373}, {0.900893604, -0.067159551}, {0.804361314, 0.253333963}, {0.70669484, 0.568819192}, {0.607643454, 0.924616769}, {0.50534969, 1.352006444}},
		{{1, -0.175252761}, {0.900893604, 0.127686649}, {0.804361314, 0.506421373}, {0.70669484, 0.870719234}, {0.607643454, 1.281040572}},
		{{1, -0.035071593}, {0.900893604, 0.33358882}, {0.804361314, 0.767707772}, {0.70669484, 1.182863756}, {0.607643454, 1.645121234}},
		{{1, 0.115465853}, {0.900893604, 0.545543337}, {0.804361314, 1.03554774}, {0.70669484, 1.49849281}},
		{{1, 0.271665613}, {0.900893604, 0.76628371}, {0.804361314, 1.310218938}},
		{{1, -0.711987963}, {0.900893604, -0.762669956}, {0.804361314, -0.376615109}, {0.70669484, -0.235055877}, {0.607643454, -0.070245503}, {0.50534969, 0.125403321}, {0.402951799, 0.308553181}, {0.29855752, 0.587913535}, {0.194662481, 0.942202325}, {0.090966981, 1.396802209}},
		{{1, -0.646728639}, {0.900893604, -0.401117427}, {0.804361314, -0.235551283}, {0.70669484, -0.060233967}, {0.607643454, 0.14348984}, {0.50534969, 0.37724166}, {0.402951799, 0.619049371}, {0.29855752, 0.963467969}, {0.194662481, 1.37378614}},
		{{1, -0.453028948}, {0.900893604, -0.320635942}, {0.804361314, -0.120282604}, {0.70669484, 0.087234487}, {0.607643454, 0.320362123}, {0.50534969, 0.592089502}, {0.402951799, 0.889508109}, {0.29855752, 1.301908884}},
		{{1, -0.380710183}, {0.900893604, -0.229398228}, {0.804361314, -0.000622286}, {0.70669484, 0.239068822}, {0.607643454, 0.503530826}, {0.50534969, 0.817159762}, {0.402951799, 1.167472801}, {0.29855752, 1.653681475}},
		{{1, -0.319546679}, {0.900893604, -0.134249438}, {0.804361314, 0.130978886}, {0.70669484, 0.395516236}, {0.607643454, 0.692023376}, {0.50534969, 1.047539408}, {0.402951799, 1.452860947}},
		{{1, -0.240754065}, {0.900893604, -0.033501723}, {0.804361314, 0.267238038}, {0.70669484, 0.559034266}, {0.607643454, 0.884900451}, {0.50534969, 1.278052802}},
		{{1, -0.164284559}, {0.900893604, 0.072922502}, {0.804361314, 0.404964189}, {0.70669484, 0.724498186}, {0.607643454, 1.079038828}, {0.50534969, 1.507652925}},
		{{1, -0.090058538}, {0.900893604, 0.181537771}, {0.804361314, 0.546655893}, {0.70669484, 0.89108509}, {0.607643454, 1.273473289}},
		{{1, -0.012792229}, {0.900893604, 0.293951908}, {0.804361314, 0.686145507}, {0.70669484, 1.058059611}, {0.607643454, 1.468216725}},
		{{1, 0.070733531}, {0.900893604, 0.402800628}, {0.804361314, 0.829371699}, {0.70669484, 1.225065224}, {0.607643454, 1.663686373}},
		{{1, 0.15080645}, {0.900893604, 0.518189103}, {0.804361314, 0.971737899}, {0.70669484, 1.393601565}},
		{{1, -0.882224198}, {0.900893604, -0.742584505}, {0.804361314, -0.732563879}, {0.70669484, -0.792845941}, {0.607643454, -0.812920439}, {0.50534969, -0.720428038}, {0.402951799, -0.781271064}, {0.29855752, -0.674241678}, {0.194662481, -0.588923593}, {0.090966981, -0.218988716}},
		{{1, -0.882224198}, {0.900893604, -0.699043164}, {0.804361314, -0.732563879}, {0.70669484, -0.661004623}, {0.607643454, -0.574264185}, {0.50534969, -0.467445967}, {0.402951799, -0.404852003}, {0.29855752, -0.201977714}, {0.194662481, 0.121680598}, {0.090966981, 0.650997381}},
		{{1, -0.882224198}, {0.900893604, -0.659472141}, {0.804361314, -0.364543221}, {0.70669484, -0.185230378}, {0.607643454, 0.023740173}, {0.50534969, 0.265521346}, {0.402951799, 0.514925054}, {0.29855752, 0.855893898}, {0.194662481, 1.2469946}, {0.090966981, 1.638903648}},
		{{1, -1.055555606}, {0.900893604, -0.287281637}, {0.804361314, -0.593027717}, {0.70669484, -0.673826449}, {0.607643454, -0.731904191}, {0.50534969, -0.71430393}, {0.402951799, -0.751381518}, {0.29855752, -0.558237806}, {0.194662481, -0.167044496}, {0.090966981, 0.415701142}},
		{{1, -0.903583288}, {0.900893604, -0.862366525}, {0.804361314, -0.849586565}, {0.70669484, -0.864456164}, {0.607643454, -0.776334709}, {0.50534969, -0.52638205}, {0.402951799, -0.411403984}, {0.29855752, -0.12430756}, {0.194662481, 0.294309724}, {0.090966981, 0.940502664}},
		{{1, -1.055555606}, {0.900893604, -0.287281637}, {0.804361314, -0.593027717}, {0.70669484, -0.673826449}, {0.607643454, -0.731904191}, {0.50534969, -0.692559977}, {0.402951799, -0.751381518}, {0.29855752, -0.546647347}, {0.194662481, -0.178083135}, {0.090966981, 0.378306044}},
		{{1, -0.772325902}, {0.900893604, -0.790982649}, {0.804361314, -0.83311471}, {0.70669484, -0.624665073}, {0.607643454, -0.465663297}, {0.50534969, -0.26185745}, {0.402951799, -0.061585622}, {0.29855752, 0.27081211}, {0.194662481, 0.752391451}, {0.090966981, 1.401444947}},
		{{1, -0.949737217}, {0.900893604, -0.083582986}, {0.804361314, 0.163660426}, {0.70669484, 0.355715079}, {0.607643454, 0.497222546}, {0.50534969, 0.644017169}, {0.402951799, 0.848014002}, {0.29855752, 1.256398963}},
		{{1, -0.91627732}, {0.900893604, -0.84270367}, {0.804361314, -0.83311471}, {0.70669484, -0.532299935}, {0.607643454, -0.342060463}, {0.50534969, -0.117213429}, {0.402951799, 0.133404431}, {0.29855752, 0.532401504}, {0.194662481, 1.094731762}},
		{{1, -1.029712427}, {0.900893604, -0.790982649}, {0.804361314, -0.779935744}, {0.70669484, -0.479304992}, {0.607643454, -0.26068521}, {0.50534969, -0.000587286}, {0.402951799, 0.287377361}, {0.29855752, 0.743362825}, {0.194662481, 1.379647804}},
		{{1, -0.949737217}, {0.900893604, -1.534745168}, {0.804361314, -1.283014796}, {0.70669484, -1.06635976}, {0.607643454, -0.676470727}, {0.50534969, -0.225516573}, {0.402951799, 0.224764712}, {0.29855752, 0.889653762}},
		{{1, -1.029712427}, {0.900893604, -1.171706011}, {0.804361314, -1.283014796}, {0.70669484, -1.06635976}, {0.090966981, -0.913986055}},
		{{1, -0.949737217}, {0.900893604, -1.534745168}, {0.804361314, -1.147232759}, {0.70669484, -1.06635976}, {0.607643454, -0.606260864}, {0.50534969, -0.168285856}, {0.402951799, 0.279378727}, {0.29855752, 0.93820941}},
		{{1, -0.903583288}, {0.900893604, -0.600611109}, {0.804361314, -0.912719604}, {0.70669484, -0.929667857}, {0.607643454, -1.037894727}, {0.50534969, -0.832371468}, {0.402951799, -0.848033713}, {0.29855752, -0.693411246}, {0.194662481, -0.388288138}, {0.090966981, 0.419518561}},
		{{1, -0.949737217}, {0.900893604, -0.84270367}, {0.804361314, -0.893726055}, {0.70669484, -0.624665073}, {0.607643454, -0.465663297}, {0.50534969, -0.24709248}, {0.402951799, 0.007253521}, {0.29855752, 0.47591647}, {0.194662481, 1.251967397}}
	};
}
